SFF_LOCATION = ""  '<---Put your collection location between the quotes. EG. "D:\EBooks\SFFebook 2010 Remaster"
'
' ****** Input file format. Note: (Tab) is used between parameters. *****
'
' B	some text							(Display msgbox containing "some text". Can use <BR> for newline)
' C	directory_Name1    						(Create directory)
' C	directory_Name1\directory_Name2					(Create SubDirectory)
' D	directory_Name1							(Delete Directory)
' D	directory_Name1\File_Name1					(Delete File)
' E	directory_Name1			<Directive>			(Only action directive If folder NOT exists)
' E	directory_Name1\File_Name1	<Directive>			(Only action directive If file NOT exists)
' I	directory_Name1			<Directive>			(Only action directive If folder exists)
' I	directory_Name1\File_Name1	<Directive>			(Only action directive If file exists)
' M	directory_Name1			directory_Name2			(Rename Directory)
' M	directory_Name1\File_Name1	directory_Name2\File_Name2	(Rename/Move File)
' R	directory_Name1\File_Name1	File_Name2			(Rename File, same location)
' R	directory_Name1\File_Name1	directory_Name1\File_Name2	(Rename/Move File)
' V	Version Number (eg 101.3)					(provide directive version to compare against SFF version)
' U	source path\Zip_Name.zip	destination path		(UNZIP file to specified path. (note: Zip is not deleted)
' Z	destination path\ZIP_Name.zip	source folder \ file		(ZIP file or folder. Note: This is a MOVE into zip file)
'  
' ***************************************
'
'#### MAIN PROGRAM #####

   Dim objFileSystem, objLogFile, objInputFile, objRollbackFile, CountSkipped, CountApplied, CountErrors, DeletedFilesDirectory
   Dim strInputFilePath, strInputFilename, inputData, strData, strAction, seperator, strPrompt, LogFilename, RollbackFilename
   Dim SFF_Version, Directive_Version, Log_Directory, objHistoryFile, Version_Data, objSFFVersionFile, SFFVersionFile
   Dim SSF_Clean_Version, Req_SFFClean_Version, Req_SFF_Collection_Version, Original_SFF_Version
   Const BIF_EDITBOX = &H10, BIF_NONEWFOLDER = &H0200, BIF_RETURNONLYFSDIRS = &H1, BIF_BROWSEINCLUDEFILES = &H4000

   seperator = "	" '(Tab)
   DeletedFilesDirectory = "_Deleted_Files"
   Log_Directory = "_Admin\"
   MoveDelay = 10
   CountSkipped = 0
   CountApplied = 0
   CountErrors  = 0
   SFF_Version = ""
   Directive_Version = ""
   Original_SFF_Version = ""
   Need_Version = ""
   Req_SFF_Collection_Version = ""
   Req_SFFClean_Version = ""
   SFF_Clean_Version = "2.06"

   Set objShell      = CreateObject("Shell.Application")
   Set objFileSystem = CreateObject("Scripting.fileSystemObject")
   strPrompt = "Please Browse to where your Science Fiction Ebook Collection is located."
   intOptions = BIF_RETURNONLYFSDIRS + BIF_NONEWFOLDER + BIF_EDITBOX
   ebookLocation     = Browse4EbookFolder(strPrompt, intOptions, SFF_LOCATION)

   If WScript.arguments.count > 0 Then 'Input file dropped on script
      strInputFilePath = WScript.arguments.item(0)
   Else
      strPrompt        = "Please Browse to where the directives (Corrections) input file is located."
      intOptions       = BIF_NONEWFOLDER + BIF_EDITBOX + BIF_BROWSEINCLUDEFILES 
      strInputFilePath = Browse4InputFile(strPrompt, intOptions, "")
   End If

   LogFilename = Log_Directory + Mid(strInputFilePath, InStrRev(strInputFilePath,"\") +1, _
                 Len(Mid(strInputFilePath, InStrRev(strInputFilePath,"\") ) ) - 5 ) + "_LOG.txt"
   RollbackFilename = Log_Directory + Mid(strInputFilePath, InStrRev(strInputFilePath,"\") +1, _
                      Len(Mid(strInputFilePath, InStrRev(strInputFilePath,"\") ) ) - 5 ) + "_ROLLBACK.txt"

   If NOT objFileSystem.FolderExists(ebookLocation + "\" + Log_Directory) Then
      objFileSystem.CreateFolder ebookLocation + "\" + Log_Directory
   End If

   ConvertUnixText2Windows strInputFilePath 'If Corrections file was made on UNIX, convert it to Windows friendly version

   Set objLogFile = objFileSystem.CreateTextFile(ebookLocation + "\" + LogFilename, True)
   Set objRollbackFile = objFileSystem.CreateTextFile(ebookLocation + "\" + RollbackFilename, True)

   SFFVersionFile = ebookLocation + "\" + Log_Directory + "SFFVersion.txt"
   Get_SFF_Version

   Set objInputFile = objFileSystem.OpenTextFile(strInputFilePath, 1)
   objLogFile.WriteLine("Actioning Directives file: " + strInputFilePath)
   objLogFile.WriteLine("Location of SFF Collection: " + ebookLocation)
   objLogFile.WriteLine("")
   inputData = Split(objInputFile.ReadAll, vbNewline)

   For each strData In inputData    
      strData = Replace(strData,"/","\") 'swap unix slash for windows one
      strAction = Split(strData,seperator)
      If Ubound(strAction) > 0 Then 'Not a blank line
         If strAction(0) = "V" Then
            Set_Directive_Version (strAction(1))
            Get_SFF_Version
            Update_SFF_Version
         End If
         If strAction(0) = "N" Then
            Set_Req_SFF_Collection_Version (strAction(1))
         End If
         If strAction(0) = "Y" Then
            Set_Required_SFFClean_Version (strAction(1))
         End If

         'Check SFF version against directive required version
         If SFF_Version <> "" and Req_SFF_Collection_Version <> "" and SFF_version < Req_SFF_Collection_Version Then
            msgbox("This Directive file requires your SFF collection to be at " + Req_SFF_Collection_Version + VBCr _
                  + "Your SFF Collection is currently at " + SFF_Version )
            objLogFile.WriteLine("ERROR: SFF Collecion version " + SFF_Version _
                                 + " is less then directive requirement " + Req_SFF_Collection_Version)
            objInputFile.Close
            objLogFile.Close
            objRollbackFile.Close
            wscript.quit
         End If

         'Check SFF Clean against required SFF Clean version
         If SFF_Clean_Version <> "" and Req_SFFClean_Version <> "" and Req_SFFClean_Version > SFF_Clean_Version Then
            msgbox("This Directive file requires SFF Clean to be at " + Req_SFFClean_Version + VBCr _
                  + "Your SFF Clean is currently at " + SFF_Clean_Version )
            objLogFile.WriteLine("ERROR: SFF Clean version " + SFF_Clean_Version _
                                 + " is less then directive requirement " + Req_SFFClean_Version)
            objInputFile.Close
            objLogFile.Close
            objRollbackFile.Close
            wscript.quit
         End If

         'Only run directives if directive > SFF version 
         If SFF_Version = "" or Directive_Version = "" or SFF_version < Directive_Version or Req_SFF_Collection_Version = "" Then
            If strAction(0) = "D" Then
               Process_Delete(strAction(1))
            End If 
            If strAction(0) = "M" OR strAction(0) = "R" Then
               Process_Modify strAction(1) , strAction(2)
            End If
            If strAction(0) = "C" Then
               Process_Create (strAction(1))
            End If
            If strAction(0) = "B" Then
               Process_MessageBox (strAction(1))
            End If
            If strAction(0) = "I" Then
               Process_If (strData)
            End If
            If strAction(0) = "E" Then
               Process_Else (strData)
            End If
            If strAction(0) = "Z" Then
               Process_Zip strAction(1) , strAction(2)
            End If
            If strAction(0) = "U" Then
               Process_Unzip strAction(1) , strAction(2)
            End If
else
msgbox("SKIP: " + SFF_Version + "=" + Directive_Version + "=" + Req_SFF_Collection_Version + "=" + strData)
         End If
      End If
   Next

   objLogFile.WriteLine(vbNewline + "SFF Clean Completed..." + vbNewline + "Applied: " + VBTab + Cstr(CountApplied) _
                + vbNewline + "Skipped: " + VBTab + Cstr(CountSkipped) + vbNewline + "Failed: " + VBTab + Cstr(CountErrors))

   objInputFile.Close
   objLogFile.Close
   If Original_SFF_Version <> "" Then 'Set Rollback SFF version
      objRollbackFile.Writeline("V" + seperator + Original_SFF_Version)
   End If
   objRollbackFile.Close
   If countApplied > 0 Then
      ReverseFileContents ebookLocation + "\" + RollbackFilename 'If you rollback you need to run everything backwards
   Else
      objFileSystem.DeleteFile ebookLocation + "\" + RollbackFilename 'Del Empty rollback file
   End If
   If InStr(strInputFilePath, "_ROLLBACK.txt") Then 'Don't keep rollback of rollback
      If objFileSystem.FileExists(ebookLocation + "\" + RollbackFilename) Then
         objFileSystem.DeleteFile ebookLocation + "\" + RollbackFilename 'Del Empty rollback file
      End If
   End IF

   TStamp = TimeStamp()
   If NOT objFileSystem.FileExists(ebookLocation + "\" + Log_Directory + "Update_History.txt") Then
      Set objHistoryFile = objFileSystem.CreateTextFile(ebookLocation + "\" + Log_Directory + "Update_History.txt", True)
      objHistoryFile.WriteLine ("TimeStamp	SFF v	Update v	Update Filename")
      objHistoryFile.WriteLine ("------------------------------------------------------------------------")
      objHistoryFile.Close
   End If
   Set objHistoryFile = objFileSystem.OpenTextFile(ebookLocation + "\" + Log_Directory + "Update_History.txt", 8)
   objHistoryFile.WriteLine(TStamp + seperator + Original_SFF_Version + seperator + Directive_Version + seperator + _
                            seperator + Mid(strInputFilePath, InStrRev(strInputFilePath,"\") + 1, 100))
   objHistoryFile.Close
   set objHistoryFile = Nothing

   Set objFileSystem = Nothing
   msgbox("SFF Clean Completed..." + vbNewline + "Applied: " + VBTab + Cstr(CountApplied) _
                                + vbNewline + "Skipped: " + VBTab + Cstr(CountSkipped) _
                                + vbNewline + "Failed: "  + VBTab + Cstr(CountErrors))

   WScript.Quit(0)

'#### END MAIN PROGRAM #####

Function Set_Directive_Version (strData)

   Directive_Version = strData

End Function

Function Set_Req_SFF_Collection_Version (strData)
   Req_SFF_Collection_Version = strData
End Function


Function Set_Required_SFFClean_Version (strData)
   Req_SFFClean_Version = strData
End Function

Function Get_SFF_Version
   If objFileSystem.FileExists(SFFVersionFile) Then
      Set objSFFVersionFile = objFileSystem.OpenTextFile(SFFVersionFile, 1)
      SFF_version = objSFFVersionFile.Readline
      objSFFVersionFile.Close
      If Original_SFF_Version = "" Then 'Set the version we will rollback to
         Original_SFF_Version = SFF_Version
      End If
   Else
      Original_SFF_Version = "100.0" 'Only 100.0 should have no SFFVersion.txt
   End If
End Function

Function Update_SFF_Version
   If NOT objFileSystem.FileExists(SFFVersionFile) Then 
      Set objSFFVersionFile = objFileSystem.CreateTextFile(ebookLocation + "\" + Log_Directory + "SFFVersion.txt", True)
      objSFFVersionFile.Close
   End If

   Set objSFFVersionFile = objFileSystem.OpenTextFile(SFFVersionFile, 2)
   objSFFVersionFile.Writeline Directive_Version
   objSFFVersionFile.Close
End Function

Function Process_MessageBox (strData)
   Dim message

   message = Replace(strData, "<BR>", VBCR)
   msgbox (message)
End Function


Function Process_If (strData)
   Dim action

   action = Split(strData,seperator)
   If objFileSystem.FileExists(ebookLocation + "\" + action(1)) or objFileSystem.FolderExists(ebookLocation + "\" + action(1)) Then

         If strAction(2) = "V" Then
            Set_Directive_Version (strAction(3))
            Get_SFF_Version
            Update_SFF_Version
         End If
         If strAction(2) = "N" Then
            Set_Req_SFF_Collection_Version (strAction(3))
         End If
         If strAction(2) = "Y" Then
            Set_Required_SFFClean_Version (strAction(3))
         End If

         If strAction(2) = "D" Then
            Process_Delete(strAction(3))
         End If 
         If strAction(2) = "M" OR strAction(2) = "R" Then
            Process_Modify strAction(3) , strAction(4)
         End If
         If strAction(2) = "C" Then
            Process_Create (strAction(3))
         End If
         If strAction(2) = "B" Then
            Process_MessageBox (strAction(3))
         End If
         If strAction(2) = "Z" Then
            Process_Zip strAction(3) , strAction(4)
         End If
         If strAction(2) = "U" Then
            Process_Unzip strAction(3) , strAction(4)
         End If
   End If
End Function

Function Process_Else (strData)
   Dim action

   action = Split(strData,seperator)

   If NOT objFileSystem.FileExists(ebookLocation + "\" + action(1)) and NOT objFileSystem.FolderExists(ebookLocation + "\" + action(1)) Then
         If strAction(2) = "V" Then
            Set_Directive_Version (strAction(3))
            Get_SFF_Version
            Update_SFF_Version
         End If
         If strAction(2) = "N" Then
            Set_Req_SFF_Collection_Version (strAction(3))
         End If
         If strAction(2) = "Y" Then
            Set_Required_SFFClean_Version (strAction(3))
         End If

         If strAction(2) = "D" Then
            Process_Delete(strAction(3))
         End If 
         If strAction(2) = "M" OR strAction(2) = "R" Then
            Process_Modify strAction(3) , strAction(4)
         End If
         If strAction(2) = "C" Then
            Process_Create (strAction(3))
         End If
         If strAction(2) = "B" Then
            Process_MessageBox (strAction(3))
         End If
         If strAction(2) = "Z" Then
            Process_Zip strAction(3) , strAction(4)
         End If
         If strAction(2) = "U" Then
            Process_Unzip strAction(3) , strAction(4)
         End If
   End If
End Function

Function Process_Zip (zip_filename, source)
   Dim oShell, drive, working_dir, zip_prog, filename

   Filename = ""
   zip_prog = """" + Left(WScript.ScriptFullName,(Len(WScript.ScriptFullName) - (Len(WScript.ScriptName) + 1))) + "\zip.exe" + """"
   drive = Left(ebookLocation,1) + ":"
   If objFileSystem.FileExists(ebookLocation + "\" + source) Then 
      working_dir = Mid(ebookLocation + "\" + source, 1, Len(ebookLocation) + InStrRev(source,"\"))
      filename = Mid(source, InStrRev(source,"\") + 1, 100)
   Else
      If objFileSystem.FolderExists(ebookLocation + "\" + source) Then 
         working_dir = ebookLocation + "\" + source
         filename = "*.*"
      End If
   End If

   If filename <> "" Then
      Set oShell = WScript.CreateObject ("WScript.Shell")
      oShell.run "cmd /C " + drive + " & CD """ + working_dir + """ & " + zip_prog + " -m -r """ _
                 + ebookLocation + "\" + zip_filename + """ " + filename ,  2, True
      Set oShell = Nothing

      If objFileSystem.FileExists(ebookLocation + "\" + zip_filename) Then
         objLogFile.WriteLine("ZIPPED: " + source + " to " + zip_filename)
         objRollbackFile.WriteLine("D" + seperator + zip_filename) ' add delete since no Move for unzip
         objRollbackFile.WriteLine("U" + seperator + zip_filename + seperator + source)
         CountApplied = CountApplied + 1
      Else
         CountErrors = CountErrors + 1
         objLogFile.WriteLine("FAILED: Zip file not created / Nothing to zip - " + zip_filename + ", " + source)
      End If
   Else
      CountErrors = CountErrors + 1
      objLogFile.WriteLine("FAILED: Can't zip files that don't exist - " + source)
   End If

End Function

Function Process_Unzip (zip_filename, destination)
   Dim oShell, drive, unzip_prog, filename

   drive = Left(ebookLocation,1) + ":"
   unzip_prog = """" + Left(WScript.ScriptFullName,(Len(WScript.ScriptFullName) - (Len(WScript.ScriptName) + 1))) + "\unzip.exe" + """"

   If objFileSystem.FileExists(ebookLocation + "\" + zip_filename) Then
      Set oShell = WScript.CreateObject ("WScript.Shell")
      oShell.run "cmd /C " + drive + " & " + unzip_prog + " -d""" + ebookLocation + "\" + destination _
                  + """ """ + ebookLocation + "\" + zip_filename + """", 2, True
      Set oShell = Nothing
      objLogFile.WriteLine("UNZIPPED: " + zip_filename + " to " + destination)
      objRollbackFile.WriteLine("Z" + seperator + zip_filename + seperator + destination)
      CountApplied = CountApplied + 1
   Else
      CountErrors = CountErrors + 1
      objLogFile.WriteLine("FAILED: source Zip file not found - " + zip_filename)
   End If

End Function


Function Process_Delete (strData)
   Dim FromFullPath, FromFolderPath, FromFileName, ToFolderPath, ToFileName, SubDirectory, CurrentDirectory, i

   FromFullPath   = ebookLocation + "\" + strData    
   If objFileSystem.FileExists(FromFullPath) Then 
      FileType = "FILE"
      If InStr(strData,"\") Then 'file with dir
         FromFolderPath = Mid(strData, 1, InStrRev(strData,"\") - 1)
         FromFileName   = Mid(strData, InStrRev(strData,"\") +1, Len(strData) - Len(FromFolderPath))
         FromFull       = FromFolderPath + "\" + FromFileName
         ToFolderPath   = DeletedFilesDirectory + "\" + FromFolderPath 
         ToFileName     = FromFileName
         ToFull         = ToFolderPath + "\" + ToFileName
      Else 'File in root dir
         FromFolderPath = ""
         FromFileName   = strData
         FromFull       = FromFileName
         ToFolderPath   = DeletedFilesDirectory
         ToFileName     = FromFileName
         ToFull         = ToFolderPath + "\" + ToFileName
      End If
   Else
      If objFileSystem.FolderExists(FromFullPath) Then
         FileType       = "FOLDER"
         FromFolderPath = strData
         FromFileName   = ""
         ToFolderPath   = DeletedFilesDirectory + "\" + FromFolderPath
         ToFileName     = FromFileName
      Else
         FileType     = "NOT_FOUND"
         ToFolderPath = ""
      End If
   End If

   If FileType <> "NOT_FOUND" Then 'create Destination directories
      SubDirectory = Split(ToFolderPath, "\")
      CurrentDirectory = ""
      For i = 0 to Ubound(SubDirectory)     
         CurrentDirectory = CurrentDirectory + "\" + SubDirectory(i)
         If Not objFileSystem.FolderExists(ebookLocation + "\" + CurrentDirectory) Then
            objFileSystem.CreateFolder ebookLocation + "\" + CurrentDirectory
         End If
      Next
   End If
   If FileType = "FILE" Then
      If Not objFileSystem.FileExists(ebookLocation + "\" + ToFull) Then 'check file not already in bin
         objFileSystem.MoveFile FromFullPath, ebookLocation + "\" + ToFull
         objLogFile.WriteLine("DELETED: " + FromFull + " to " + ToFull)
         objRollbackFile.WriteLine("M" + seperator + ToFull + seperator + FromFull)
         CountApplied = CountApplied + 1
      Else 'file already in bin         
         objFileSystem.DeleteFile ebookLocation + "\" + ToFull
         objFileSystem.MoveFile FromFullPath, ebookLocation + "\" + ToFull
         objLogFile.WriteLine("DELETED: " + FromFull + " to " + ToFull)
         objRollbackFile.WriteLine("M" + seperator + ToFull + seperator + FromFull)
         CountApplied = CountApplied + 1
      End If
   Else
      If FileType = "FOLDER" Then
         Set objFolder = objFileSystem.GetFolder(FromFullPath)
         Set objFiles = objFolder.Files
         Set objSubFolders = objFolder.SubFolders
         If objFiles.Count = 0 AND objSubFolders.Count = 0 Then 'Folder is empty
            objFileSystem.DeleteFolder FromFullPath 
            objLogFile.WriteLine("DELETED: " + FromFolderPath + " to " + ToFolderPath)
            objRollbackFile.WriteLine("C" + seperator + FromFolderPath)
            CountApplied = CountApplied + 1
         Else
            CountSkipped = CountSkipped + 1 
            objLogFile.WriteLine("SKIPPED: Delete request on Folder that is NOT empty: " + strData)
         End If
      Else
         CountSkipped = CountSkipped + 1 
         objLogFile.WriteLine("SKIPPED: Delete request on File/Folder that doesn't exist: " + strData)
      End If
   End If
End Function

Function Process_Modify (OldName, NewName)
   Dim FromFullPath, FromFolderPath, FromFileName, FromFull, SubDirectory, CurrentDirectory, i 
   Dim ToFullPath, ToFolderPath, ToFileName, ToFull, FileType

   FromFullPath   = ebookLocation + "\" + OldName    
   If objFileSystem.FileExists(FromFullPath) Then 
      FileType = "FILE"
      If InStr(OldName,"\") Then 'file with dir
         FromFolderPath = Mid(OldName, 1, InStrRev(OldName,"\") - 1)
         FromFileName   = Mid(OldName, InStrRev(OldName,"\") +1, Len(OldName) - Len(FromFolderPath))
         FromFull       = FromFolderPath + "\" + FromFileName
      Else 'File in root dir
         FromFolderPath = ""
         FromFileName   = OldName
         FromFull       = FromFileName
      End If
   Else
      If objFileSystem.FolderExists(FromFullPath) Then
         FileType       = "FOLDER"
         FromFolderPath = OldName
         FromFileName   = ""
         FromFull       = FromFolderPath
      Else
         FileType     = "NOT_FOUND"
         ToFolderPath = ""
      End If
   End If
   ToFullPath = ebookLocation + "\" + NewName
   If FileType = "FILE" Then 
      If InStr(NewName,"\") Then 'file with dir
         ToFolderPath = Mid(NewName, 1, InStrRev(NewName,"\") - 1)
         ToFileName   = Mid(NewName, InStrRev(NewName,"\") +1, Len(NewName) - Len(ToFolderPath))
         ToFull       = ToFolderPath + "\" + ToFileName
      Else 'File in root dir
         ToFolderPath = ""
         ToFileName   = NewName
         ToFull       = ToFileName
      End If
   Else
      If FileType = "FOLDER" Then
         ToFolderPath = NewName
         ToFileName   = ""
         ToFull       = ToFolderPath
      End If
   End If
   If strAction(0) = "R" Then 'handle R directive which doesn't enforce specifying full destination path
      ToFolderPath = FromFolderPath
      If ToFolderPath = "" Then
         ToFull = ToFileName
      Else
         If ToFileName = "" Then
            ToFull = FromFolderPath 
         Else
            ToFull = FromFolderPath + "\" + ToFileName 
         End If
      End If
      ToFullPath = ebookLocation + "\" + ToFull
   End IF
   If ToFolderPath = "" and InStr(ToFileName,".") = 0 Then 'Handle move where only dest directory is given
      ToFolderPath = ToFileName
      ToFileName = FromFileName
      ToFull = ToFolderPath + "\" + ToFileName
   End If

   If FileType <> "NOT_FOUND" Then 'create Destination directories
      SubDirectory = Split(ToFolderPath, "\")
      CurrentDirectory = ""
      For i = 0 to Ubound(SubDirectory) - 1
         CurrentDirectory = CurrentDirectory + "\" + SubDirectory(i)
         If Not objFileSystem.FolderExists(ebookLocation + "\" + CurrentDirectory) Then
            objFileSystem.CreateFolder ebookLocation + "\" + CurrentDirectory
         End If
      Next
   End If
   If FileType = "FILE" Then
      If Not objFileSystem.FileExists(ebookLocation + "\" + ToFull) Then 'check dest file doesn't already exist
         If objFileSystem.FolderExists(ebookLocation + "\" + ToFolderPath) Then 'Check Destination folder exists to put file
            objFileSystem.MoveFile FromFullPath, ebookLocation + "\" + ToFull
            objLogFile.WriteLine("MODIFIED: " + FromFull + " to " + ToFull)
            objRollbackFile.WriteLine("M" + seperator + ToFull + seperator + FromFull)
            CountApplied = CountApplied + 1
         Else
            CountErrors = CountErrors + 1
            objLogFile.WriteLine("FAILED: Destination Folder does not exist: " + ToFolderPath)
         End If
      Else
         If LCase(FromFUll) = LCase(ToFull) Then 'Rename to same name with different case
            Set objF = objFileSystem.GetFile(FromFullPath)
            objF.Move ToFullPath + "_" 'Temp name since you can't rename to same name
            WScript.sleep MoveDelay 'allow slow OS to action the change before we change it again
            objF.Move ToFullPath
            CountApplied = CountApplied + 1
            objLogFile.WriteLine("MODIFIED: " + FromFull + " to " + ToFull)
            objRollbackFile.WriteLine("M" + seperator + ToFull + seperator + FromFull)
         Else
            CountErrors = CountErrors + 1
            objLogFile.WriteLine("FAILED: Destination filename already exists: " + ToFull)
         End If
      End If
   Else
      If FileType = "FOLDER" Then
         If NOT objFileSystem.FolderExists(ToFullPath) Then 'Dest folder doesn't exist
            objFileSystem.MoveFolder FromFullPath, ToFullPath
            objLogFile.WriteLine("MODIFIED: " + FromFolderPath + " to " + ToFolderPath)
            objRollbackFile.WriteLine("M" + seperator + ToFolderPath + seperator + FromFolderPath)
            CountApplied = CountApplied + 1
         Else
            If LCase(FromFUllPath) = LCase(ToFullPath) Then 'Rename to same name with different case
               Set objFolder = objFileSystem.GetFolder(FromFullPath)
               objFolder.Move ToFullPath + "_" 'create temp name since can't rename to same name
               WScript.sleep MoveDelay 'allow slow OS to action the change before we change it again
               objFolder.Move ToFullPath
               objLogFile.WriteLine("MODIFIED: " + FromFull + " to " + ToFull)
               objRollbackFile.WriteLine("M" + seperator + ToFull + seperator + FromFull)
               CountApplied = CountApplied + 1
            Else
               CountErrors = CountErrors + 1
               objLogFile.WriteLine("FAILED: Destination Folder already exists: " + ToFull)
            End If
         End If
      Else
         CountSkipped = CountSkipped + 1 
         objLogFile.WriteLine("SKIPPED: Modify request on File/Folder that doesn't exist: " + OldName)
      End If
   End If
End Function

Function Process_Create (strData)
   Dim target, objFolder, objFiles, subDirectory, CurrentDirectory, i

   If Not objFileSystem.FolderExists(ebookLocation + "\" + strData) Then 'create Destination directories
      SubDirectory = Split(strData, "\")
      CurrentDirectory = ""
      For i = 0 to Ubound(SubDirectory)     
         CurrentDirectory = CurrentDirectory + "\" + SubDirectory(i)
         If Not objFileSystem.FolderExists(ebookLocation + "\" + CurrentDirectory) Then
            objFileSystem.CreateFolder ebookLocation + "\" + CurrentDirectory
         End If
      Next
      CountApplied = CountApplied + 1
      objLogFile.WriteLine("CREATED: " + strData)
      objRollbackFile.WriteLine("D" + seperator + strData)
   Else
      CountSkipped = CountSkipped + 1 'Folder already there
      objLogFile.WriteLine("SKIPPED: Create Folder that already exists: " + strData)
   End If 
End Function

Function Browse4EbookFolder(strPrompt, intOptions, strRoot)  'Generate browse window to find SFF Location
   Dim objFolder, objFolderItem
   On Error Resume Next

   Set objFolder = objShell.BrowseForFolder(0, strPrompt, intOptions, strRoot)
   If (objFolder Is Nothing) Then
     Wscript.Quit
   End If
   Set objFolderItem = objFolder.Self
   Browse4EbookFolder = objFolderItem.Path
   Set objFolderItem = Nothing
   Set objFolder = Nothing
End Function

Function ConvertUnixText2Windows(Filename) 
   Dim fso, ts, s, s1

   Set fso = CreateObject("Scripting.FileSystemObject")
   Set ts = fso.OpenTextFile(Filename, 1, False)
   s = ts.ReadAll
   ts.Close
   Set ts = Nothing
   s1 = Replace(s, vbCrLf, vbCr, 1, -1, 0)
   s1 = Replace(s1, vbLf, vbCr, 1, -1, 0)
   s1 = Replace(s1, vbCr, vbCrLf, 1, -1, 0)
   Set ts = fso.CreateTextFile(Filename, True)
   ts.Write s1
   ts.Close
   Set ts = Nothing
   Set fso = Nothing
End Function

Function ReverseFileContents(Filename)
   Dim arrLines(), i

   Set objFSO = CreateObject("Scripting.FileSystemObject")
   Set objFile = objFSO.OpenTextFile(Filename, 1)
   i = 0
   Do Until objFile.AtEndOfStream
      Redim Preserve arrLines(i)
      arrLines(i) = objFile.ReadLine
      i = i + 1
   Loop
   objFile.Close
   Set objFile = objFSO.OpenTextFile(Filename, 2)
   For i = Ubound(arrLines) to LBound(arrLines) Step -1
      objFile.WriteLine arrLines(i)
   Next
   objFile.Close
   Set objFile = Nothing
End Function

Function TimeStamp() 'return timestamp as YYYYMMDDHHMMSS
   Dim SplitTime, SplitDate, iDate, iTime

   myTime = Now
   myHour = CStr(Hour(myTime))
   myMinute = CStr(Minute(myTime))
   mySecond = CStr(Second(myTime))
   myDay = CStr(Day(mytime))
   myMonth = CStr(Month(mytime))
   myYear = CStr(Year(mytime))
   
   iDate = Right("0"+myYear,4)+ Right("0"+mymonth,2)+Right("0"+myDay,2)
   iTime = Right("0"+myHour,2)+ Right("0"+myminute,2)+Right("0"+mysecond,2)
   TimeStamp = iDate + iTime
End Function

Function Browse4InputFile(strPrompt, intOptions, strRoot)  'Generate browse window to find input file 
   Dim objWord
   Const msoFileDialogOpen = 1

   Set objWord = CreateObject("Word.Application") ' Req: MS Word installed to use file dialog
   objWord.ChangeFileOpenDirectory(ebookLocation) ' since Vista/Win7 version doesn't work. Thanks MS.
   objWord.FileDialog(msoFileDialogOpen).Title = "Please select the Directives (Corrections) file to process."
   objWord.FileDialog(msoFileDialogOpen).AllowMultiSelect = False
   If objWord.FileDialog(msoFileDialogOpen).Show = -1 Then
     objWord.WindowState = 2
     For Each objFile in objWord.FileDialog(msoFileDialogOpen).SelectedItems
        Browse4InputFile = objFile
     Next     
   Else
      objWord.Quit
      Wscript.Quit
   End If
   objWord.Quit
   set objWord = Nothing
End Function